;
; LSD
;
; Copyright(c) LADsoft
;
; David Lindauer, gclind01@starbase.spd.louisville.edu
;
;
; opcodes.asm
;
; Locate the opcode table entry for a given opcode byte
;
	;MASM MODE
	.386p
include  segs.asi 
include  opcodes.asi 

	PUBLIC	FindOpcode

seg386data	SEGMENT	
; This is a table of mnemonics for the dissassembler
;
opn_add	db	"add",0
opn_push	db	"push",0
opn_pop	db	"pop",0
opn_or	db	"or",0
opn_adc	db	"adc",0
opn_sbb	db	"sbb",0
opn_and	db	"and",0
opn_daa	db	"daa",0
opn_sub	db	"sub",0
opn_das	db	"das",0
opn_xor	db	"xor",0
opn_aaa	db	"aaa",0
opn_cmp	db	"cmp",0
opn_aas	db	"aas",0
opn_inc	db	"inc",0
opn_dec	db	"dec",0
opn_pusha	db	"pusha",0
opn_popa	db	"popa",0
opn_bound	db	"bound",0
opn_arpl	db	"arpl",0
opn_imul	db	"imul",0
opn_insb	db	"insb",0
opn_ins	db	"ins",0
opn_outsb	db	"outsb",0
opn_outs	db	"outs",0
opn_jo	db	"jo",0
opn_jno	db	"jno",0
opn_jb	db	"jb",0
opn_jnb	db	"jnb",0
opn_jz	db	"jz",0
opn_jnz	db	"jnz",0
opn_jbe	db	"jbe",0
opn_ja	db	"ja",0
opn_js	db	"js",0
opn_jns	db	"jns",0
opn_jp	db	"jp",0
opn_jnp	db	"jnp",0
opn_jl	db	"jl",0
opn_jge	db	"jge",0
opn_jle	db	"jle",0
opn_jg	db	"jg",0
opn_test	db	"test",0
opn_xchg	db	"xchg",0
opn_mov	db	"mov",0
opn_lea	db	"lea",0
opn_nop	db	"nop",0
opn_cbw	db	"cbw",0
opn_cwd	db	"cwd",0
opn_call	db	"call",0
opn_wait	db	"wait",0
opn_pushf	db	"pushf",0
opn_popf	db	"popf",0
opn_sahf	db	"sahf",0
opn_lahf	db	"lahf",0
opn_movs	db	"movs",0
opn_cmps	db	"cmps",0
opn_stos	db	"stos",0
opn_lods	db	"lods",0
opn_scas	db	"scas",0
opn_movsb	db	"movsb",0
opn_cmpsb	db	"cmpsb",0
opn_stosb	db	"stosb",0
opn_lodsb	db	"lodsb",0
opn_scasb	db	"scasb",0
opn_rol	db	"rol",0
opn_ror	db	"ror",0
opn_rcl	db	"rcl",0
opn_rcr	db	"rcr",0
opn_shl	db	"shl",0
opn_shr	db	"shr",0
opn_sar	db	"sar",0
opn_ret	db	"ret",0
opn_les	db	"les",0
opn_lds	db	"lds",0
opn_enter	db	"enter",0
opn_retf	db	"retf",0
opn_int	db	"int",0
opn_into	db	"into",0
opn_iret	db	"iret",0
opn_leave	db	"leave",0
opn_aam	db	"aam",0
opn_aad	db	"aad",0
opn_xlat	db	"xlat",0
opn_loopnz	db	"loopnz",0
opn_loopz	db	"loopz",0
opn_loop	db	"loop",0
opn_jcxz	db	"jcxz",0
opn_in	db	"in",0
opn_out	db	"out",0
opn_jmp	db	"jmp",0
opn_lock	db	"lock",0
opn_repnz	db	"repnz",0
opn_repz	db	"repz",0
opn_hlt	db	"hlt",0
opn_cmc	db	"cmc",0
opn_not	db	"not",0
opn_neg	db	"neg",0
opn_mul	db	"mul",0
opn_div	db	"div",0
opn_idiv	db	"idiv",0
opn_clc	db	"clc",0
opn_stc	db	"stc",0
opn_cli	db	"cli",0
opn_sti	db	"sti",0
opn_cld	db	"cld",0
opn_std	db	"std",0
opn_movsx	db	"movsx",0
opn_movzx	db	"movzx",0
opn_lfs	db	"lfs",0
opn_lgs	db	"lgs",0
opn_lss	db	"lss",0
opn_clts	db	"clts",0
opn_shld	db	"shld",0
opn_shrd	db	"shrd",0
opn_bsf	db	"bsf",0
opn_bsr	db	"bsr",0
opn_bt	db	"bt",0
opn_bts	db	"bts",0
opn_btr	db	"btr",0
opn_btc	db	"btc",0
opn_ibts	db	"ibts",0
opn_xbts	db	"xbts",0
opn_seto	db	"seto",0
opn_setno	db	"setno",0
opn_setb	db	"setb",0
opn_setnb	db	"setnb",0
opn_setz	db	"setz",0
opn_setnz	db	"setnz",0
opn_setbe	db	"setbe",0
opn_seta	db	"seta",0
opn_sets	db	"sets",0
opn_setns	db	"setns",0
opn_setp	db	"setp",0
opn_setnp	db	"setnp",0
opn_setl	db	"setl",0
opn_setge	db	"setge",0
opn_setle	db	"setle",0
opn_setg	db	"setg",0
opn_lar	db	"lar",0
opn_lsl	db	"lsl",0
opn_lgdt	db	"lgdt",0
opn_lidt	db	"lidt",0
opn_lldt	db	"lldt",0
opn_lmsw	db	"lmsw",0
opn_ltr	db	"ltr",0
opn_sgdt	db	"sgdt",0
opn_sidt	db	"sidt",0
opn_sldt	db	"sldt",0
opn_smsw	db	"smsw",0
opn_str	db	"str",0
opn_verr	db	"verr",0
opn_verw	db	"verw",0
opn_fnop	db	"fnop",0
opn_fchs	db	"fchs",0
opn_fabs	db	"fabs",0
opn_ftst	db	"ftst",0
opn_fxam	db	"fxam",0
opn_fld1	db	"fld1",0
opn_fldl2t	db	"fldl2t",0
opn_fldl2e	db	"fldl2e",0
opn_fldpi	db	"fldpi",0
opn_fldlg2	db	"fldlg2",0
opn_fldln2	db	"fldln2",0
opn_fldz	db	"fldz",0
opn_f2xm1	db	"f2xm1",0
opn_fyl2x	db	"fyl2x",0
opn_fptan	db	"fptan",0
opn_fpatan	db	"fpatan",0
opn_fprem1	db	"fprem1",0
opn_fxtract	db	"fxtract",0
opn_fdecstp	db	"fdecstp",0
opn_fincstp	db	"fincstp",0
opn_fprem	db	"fprem",0
opn_fyl2xp1	db	"fyl2xp1",0
opn_fsqrt	db	"fsqrt",0
opn_fsincos	db	"fsincos",0
opn_frndint	db	"frndint",0
opn_fscale	db	"fscale",0
opn_fsin	db	"fsin",0
opn_fcos	db	"fcos",0
opn_fucompp	db	"fucompp",0
opn_feni	db	"feni",0
opn_fdisi	db	"fdisi",0
opn_fclex	db	"fclex",0
opn_finit	db	"finit",0
opn_fsetpm	db	"fsetpm",0
opn_fcompp	db	"fcompp",0
opn_fld	db	"fld",0
opn_fxch	db	"fxch",0
opn_fstp	db	"fstp",0
opn_esc	db	"esc",0
opn_fldenv	db	"fldenv",0
opn_fldcw	db	"fldcw",0
opn_fstenv	db	"fstenv",0
opn_fstcw	db	"fstcw",0
opn_ffree	db	"ffree",0
opn_fst	db	"fst",0
opn_fucom	db	"fucom",0
opn_fucomp	db	"fucomp",0
opn_frstor	db	"frstor",0
opn_fsave	db	"fsave",0
opn_fstsw	db	"fstsw",0
opn_fbld	db	"fbld",0
opn_fild	db	"fild",0
opn_fbstp	db	"fbstp",0
opn_fistp	db	"fistp",0
opn_fmul	db	"fmul",0
opn_fcom	db	"fcom",0
opn_fsub	db	"fsub",0
opn_fdiv	db	"fdiv",0
opn_fadd	db	"fadd",0
opn_fcomp	db	"fcomp",0
opn_fiadd	db	"fiadd",0
opn_fimul	db	"fimul",0
opn_ficom	db	"ficom",0
opn_ficomp	db	"ficomp",0
opn_fisub	db	"fisub",0
opn_fidiv	db	"fidiv",0
opn_fist	db	"fist",0

;
; Following is a table of opcodes.  Each entry consists of a mask value,
; a comparison value, a pointer to the name, the addressing mode to be
; used in dissassembly, and the base length of the instruction (possibly
; modified by the exact addressing mode encountered)
;
base0	dw	0fch
	dw	00h
	dd	dgroup:opn_add
	db	 OP_REGRMREG
	db	2

	dw	0e7h
	dw	06h
	dd	dgroup:opn_push
	db	 OP_SEG35
	db	1

	dw	0feh
	dw	04h
	dd	dgroup:opn_add
	db	 OP_ACCIMM
	db	1

	dw	0e7h
	dw	07h
	dd	dgroup:opn_pop
	db	 OP_SEG35
	db	1

	dw	0fch
	dw	08h
	dd	dgroup:opn_or
	db	 OP_REGRMREG
	db	2

	dw	0feh
	dw	0ch
	dd	dgroup:opn_or
	db	 OP_ACCIMM
	db	1

	dw	0fch
	dw	010h
	dd	dgroup:opn_adc
	db	 OP_REGRMREG
	db	2

	dw	0feh
	dw	014h
	dd	dgroup:opn_adc
	db	 OP_ACCIMM
	db	1

	dw	0fch
	dw	018h
	dd	dgroup:opn_sbb
	db	 OP_REGRMREG
	db	2

	dw	0feh
	dw	01ch
	dd	dgroup:opn_sbb
	db	 OP_ACCIMM
	db	1

	dw	0
	dw	0
	dd	0
	dw	0
	dw	0

base1	dw	0fch
	dw	020h
	dd	dgroup:opn_and
	db	 OP_REGRMREG
	db	2

	dw	0feh
	dw	024h
	dd	dgroup:opn_and
	db	 OP_ACCIMM
	db	1

	dw	0ffh
	dw	027h
	dd	dgroup:opn_daa
	db	 OP_CODEONLY
	db	1

	dw	0fch
	dw	028h
	dd	dgroup:opn_sub
	db	 OP_REGRMREG
	db	2

	dw	0feh
	dw	02ch
	dd	dgroup:opn_sub
	db	 OP_ACCIMM
	db	1

	dw	0ffh
	dw	02fh
	dd	dgroup:opn_das
	db	 OP_CODEONLY
	db	1

	dw	0fch
	dw	030h
	dd	dgroup:opn_xor
	db	 OP_REGRMREG
	db	2

	dw	0feh
	dw	034h
	dd	dgroup:opn_xor
	db	 OP_ACCIMM
	db	1

	dw	0ffh
	dw	037h
	dd	dgroup:opn_aaa
	db	 OP_CODEONLY
	db	1

	dw	0fch
	dw	038h
	dd	dgroup:opn_cmp
	db	 OP_REGRMREG
	db	2

	dw	0feh
	dw	03ch
	dd	dgroup:opn_cmp
	db	 OP_ACCIMM
	db	1

	dw	0ffh
	dw	03fh
	dd	dgroup:opn_aas
	db	 OP_CODEONLY
	db	1

	dw	0
	dw	0
	dd	0
	dw	0
	dw	0

base2	dw	0f8h
	dw	040h
	dd	dgroup:opn_inc
	db	 OP_WREG02
	db	1

	dw	0f8h
	dw	048h
	dd	dgroup:opn_dec
	db	 OP_WREG02
	db	1

	dw	0f8h
	dw	050h
	dd	dgroup:opn_push
	db	 OP_WREG02
	db	1

	dw	0f8h
	dw	058h
	dd	dgroup:opn_pop
	db	 OP_WREG02
	db	1

	dw	0
	dw	0
	dd	0
	dw	0
	dw	0

base3	dw	0ffh
	dw	060h
	dd	dgroup:opn_pusha
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	061h
	dd	dgroup:opn_popa
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	062h
	dd	dgroup:opn_bound
	db	 OP_WORDREGRM
	db	2

	dw	0ffh
	dw	063h
	dd	dgroup:opn_arpl
	db	 OP_WORDRMREG
	db	2

	dw	0fdh
	dw	068h
	dd	dgroup:opn_push
	db	 OP_IMM
	db	1

	dw	0fdh
	dw	069h
	dd	dgroup:opn_imul
	db	 OP_IMUL
	db	2

	dw	0ffh
	dw	06ch
	dd	dgroup:opn_insb
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	06dh
	dd	dgroup:opn_ins
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	06eh
	dd	dgroup:opn_outsb
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	06fh
	dd	dgroup:opn_outs
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	070h
	dd	dgroup:opn_jo
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	071h
	dd	dgroup:opn_jno
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	072h
	dd	dgroup:opn_jb
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	073h
	dd	dgroup:opn_jnb
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	074h
	dd	dgroup:opn_jz
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	075h
	dd	dgroup:opn_jnz
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	076h
	dd	dgroup:opn_jbe
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	077h
	dd	dgroup:opn_ja
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	078h
	dd	dgroup:opn_js
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	079h
	dd	dgroup:opn_jns
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	07ah
	dd	dgroup:opn_jp
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	07bh
	dd	dgroup:opn_jnp
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	07ch
	dd	dgroup:opn_jl
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	07dh
	dd	dgroup:opn_jge
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	07eh
	dd	dgroup:opn_jle
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	07fh
	dd	dgroup:opn_jg
	db	 OP_SHORTBRANCH
	db	2

	dw	0
	dw	0
	dd	0
	dw	0
	dw	0

base4	dw	038fch
	dw	080h
	dd	dgroup:opn_add
	db	 OP_RMIMMSIGNED
	db	2

	dw	038feh
	dw	0880h
	dd	dgroup:opn_or
	db	 OP_RMIMMSIGNED
	db	2

	dw	038fch
	dw	0880h
	dd	dgroup:opn_or
	db	 OP_RMIMMSIGNED
	db	2

	dw	038fch
	dw	01080h
	dd	dgroup:opn_adc
	db	 OP_RMIMMSIGNED
	db	2

	dw	038fch
	dw	01880h
	dd	dgroup:opn_sbb
	db	 OP_RMIMMSIGNED
	db	2

	dw	038feh
	dw	02080h
	dd	dgroup:opn_and
	db	 OP_RMIMMSIGNED
	db	2

	dw	038fch
	dw	02080h
	dd	dgroup:opn_and
	db	 OP_RMIMMSIGNED
	db	2

	dw	038fch
	dw	02880h
	dd	dgroup:opn_sub
	db	 OP_RMIMMSIGNED
	db	2

	dw	038feh
	dw	03080h
	dd	dgroup:opn_xor
	db	 OP_RMIMMSIGNED
	db	2

	dw	038fch
	dw	03080h
	dd	dgroup:opn_xor
	db	 OP_RMIMMSIGNED
	db	2

	dw	038fch
	dw	03880h
	dd	dgroup:opn_cmp
	db	 OP_RMIMMSIGNED
	db	2

	dw	0feh
	dw	084h
	dd	dgroup:opn_test
	db	 OP_REGRM
	db	2

	dw	0feh
	dw	086h
	dd	dgroup:opn_xchg
	db	 OP_REGRM
	db	2

	dw	0fch
	dw	088h
	dd	dgroup:opn_mov
	db	 OP_REGRMREG
	db	2

	dw	020fdh
	dw	08ch
	dd	dgroup:opn_mov
	db	 OP_SEGRMSEG
	db	2

	dw	0fdh
	dw	08ch
	dd	dgroup:opn_mov
	db	 OP_SEGRMSEG
	db	2

	dw	0ffh
	dw	08dh
	dd	dgroup:opn_lea
	db	 OP_WORDREGRM
	db	2

	dw	038ffh
	dw	08fh
	dd	dgroup:opn_pop
	db	 OP_NOSTRICTRM
	db	2

	dw	0ffh
	dw	090h
	dd	dgroup:opn_nop
	db	 OP_CODEONLY
	db	1

	dw	0f8h
	dw	090h
	dd	dgroup:opn_xchg
	db	 OP_ACCREG02
	db	1

	dw	0ffh
	dw	098h
	dd	dgroup:opn_cbw
	db	 OP_CBW
	db	1

	dw	0ffh
	dw	099h
	dd	dgroup:opn_cwd
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	09ah
	dd	dgroup:opn_call
	db	 OP_SEGBRANCH
	db	5

	dw	0ffh
	dw	09bh
	dd	dgroup:opn_wait
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	09ch
	dd	dgroup:opn_pushf
	db	 OP_INSWORDSIZE
	db	1

	dw	0ffh
	dw	09dh
	dd	dgroup:opn_popf
	db	 OP_INSWORDSIZE
	db	1

	dw	0ffh
	dw	09eh
	dd	dgroup:opn_sahf
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	09fh
	dd	dgroup:opn_lahf
	db	 OP_CODEONLY
	db	1

	dw	0
	dw	0
	dd	0
	dw	0
	dw	0

base5	dw	0feh
	dw	0a0h
	dd	dgroup:opn_mov
	db	 OP_ACCABS
	db	3

	dw	0feh
	dw	0a2h
	dd	dgroup:opn_mov
	db	 OP_ABSACC
	db	3

	dw	0ffh
	dw	0a5h
	dd	dgroup:opn_movs
	db	 OP_INSWORDSIZE
	db	1

	dw	0ffh
	dw	0a7h
	dd	dgroup:opn_cmps
	db	 OP_INSWORDSIZE
	db	1

	dw	0feh
	dw	0a8h
	dd	dgroup:opn_test
	db	 OP_ACCIMM
	db	1

	dw	0ffh
	dw	0abh
	dd	dgroup:opn_stos
	db	 OP_INSWORDSIZE
	db	1

	dw	0ffh
	dw	0adh
	dd	dgroup:opn_lods
	db	 OP_INSWORDSIZE
	db	1

	dw	0ffh
	dw	0afh
	dd	dgroup:opn_scas
	db	 OP_INSWORDSIZE
	db	1

	dw	0ffh
	dw	0a4h
	dd	dgroup:opn_movsb
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0a6h
	dd	dgroup:opn_cmpsb
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0aah
	dd	dgroup:opn_stosb
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0ach
	dd	dgroup:opn_lodsb
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0aeh
	dd	dgroup:opn_scasb
	db	 OP_CODEONLY
	db	1

	dw	0f0h
	dw	0b0h
	dd	dgroup:opn_mov
	db	 OP_ACCIMMB3
	db	1

	dw	0
	dw	0
	dd	0
	dw	0
	dw	0

base6	dw	038feh
	dw	0c0h
	dd	dgroup:opn_rol
	db	 OP_RMSHIFT
	db	2

	dw	038feh
	dw	08c0h
	dd	dgroup:opn_ror
	db	 OP_RMSHIFT
	db	2

	dw	038feh
	dw	010c0h
	dd	dgroup:opn_rcl
	db	 OP_RMSHIFT
	db	2

	dw	038feh
	dw	018c0h
	dd	dgroup:opn_rcr
	db	 OP_RMSHIFT
	db	2

	dw	038feh
	dw	020c0h
	dd	dgroup:opn_shl
	db	 OP_RMSHIFT
	db	2

	dw	038feh
	dw	028c0h
	dd	dgroup:opn_shr
	db	 OP_RMSHIFT
	db	2

	dw	038feh
	dw	038c0h
	dd	dgroup:opn_sar
	db	 OP_RMSHIFT
	db	2

	dw	0ffh
	dw	0c2h
	dd	dgroup:opn_ret
	db	 OP_RET
	db	3

	dw	0ffh
	dw	0c3h
	dd	dgroup:opn_ret
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0c4h
	dd	dgroup:opn_les
	db	 OP_WORDREGRM
	db	2

	dw	0ffh
	dw	0c5h
	dd	dgroup:opn_lds
	db	 OP_WORDREGRM
	db	2

	dw	038feh
	dw	0c6h
	dd	dgroup:opn_mov
	db	 OP_RMIMM
	db	2

	dw	0ffh
	dw	0c8h
	dd	dgroup:opn_enter
	db	 OP_ENTER
	db	4

	dw	0ffh
	dw	0cah
	dd	dgroup:opn_retf
	db	 OP_RET
	db	3

	dw	0ffh
	dw	0cbh
	dd	dgroup:opn_retf
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0cch
	dd	dgroup:opn_int
	db	 OP_INTR
	db	1

	dw	0ffh
	dw	0cdh
	dd	dgroup:opn_int
	db	 OP_INTR
	db	2

	dw	0ffh
	dw	0ceh
	dd	dgroup:opn_into
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0cfh
	dd	dgroup:opn_iret
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0c9h
	dd	dgroup:opn_leave
	db	 OP_CODEONLY
	db	1

	dw	038fch
	dw	0d0h
	dd	dgroup:opn_rol
	db	 OP_RMSHIFT
	db	2

	dw	038fch
	dw	08d0h
	dd	dgroup:opn_ror
	db	 OP_RMSHIFT
	db	2

	dw	038fch
	dw	010d0h
	dd	dgroup:opn_rcl
	db	 OP_RMSHIFT
	db	2

	dw	038fch
	dw	018d0h
	dd	dgroup:opn_rcr
	db	 OP_RMSHIFT
	db	2

	dw	038fch
	dw	020d0h
	dd	dgroup:opn_shl
	db	 OP_RMSHIFT
	db	2

	dw	038fch
	dw	028d0h
	dd	dgroup:opn_shr
	db	 OP_RMSHIFT
	db	2

	dw	038fch
	dw	038d0h
	dd	dgroup:opn_sar
	db	 OP_RMSHIFT
	db	2

	dw	0ffffh
	dw	0ad4h
	dd	dgroup:opn_aam
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0ad5h
	dd	dgroup:opn_aad
	db	 OP_CODEONLY
	db	2

	dw	0ffh
	dw	0d7h
	dd	dgroup:opn_xlat
	db	 OP_CODEONLY
	db	1

	dw	0
	dw	0
	dd	0
	dw	0
	dw	0

base7	dw	0ffh
	dw	0e0h
	dd	dgroup:opn_loopnz
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	0e1h
	dd	dgroup:opn_loopz
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	0e2h
	dd	dgroup:opn_loop
	db	 OP_SHORTBRANCH
	db	2

	dw	0ffh
	dw	0e3h
	dd	dgroup:opn_jcxz
	db	 OP_SHORTBRANCH
	db	2

	dw	0feh
	dw	0e4h
	dd	dgroup:opn_in
	db	 OP_PORTACCPORT
	db	2

	dw	0feh
	dw	0e6h
	dd	dgroup:opn_out
	db	 OP_PORTACCPORT
	db	2

	dw	0ffh
	dw	0e8h
	dd	dgroup:opn_call
	db	 OP_BRANCH
	db	3

	dw	0ffh
	dw	0e9h
	dd	dgroup:opn_jmp
	db	 OP_BRANCH
	db	3

	dw	0ffh
	dw	0eah
	dd	dgroup:opn_jmp
	db	 OP_SEGBRANCH
	db	5

	dw	0ffh
	dw	0ebh
	dd	dgroup:opn_jmp
	db	 OP_SHORTBRANCH
	db	2

	dw	0feh
	dw	0ech
	dd	dgroup:opn_in
	db	 OP_ACCDX
	db	1

	dw	0feh
	dw	0eeh
	dd	dgroup:opn_out
	db	 OP_DXACC
	db	1

	dw	0ffh
	dw	0f0h
	dd	dgroup:opn_lock
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0f2h
	dd	dgroup:opn_repnz
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0f3h
	dd	dgroup:opn_repz
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0f4h
	dd	dgroup:opn_hlt
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0f5h
	dd	dgroup:opn_cmc
	db	 OP_CODEONLY
	db	1

	dw	038feh
	dw	0f6h
	dd	dgroup:opn_test
	db	 OP_RMIMM
	db	2

	dw	038feh
	dw	010f6h
	dd	dgroup:opn_not
	db	 OP_RM 
	db	2

	dw	038feh
	dw	018f6h
	dd	dgroup:opn_neg
	db	 OP_RM 
	db	2

	dw	038feh
	dw	020f6h
	dd	dgroup:opn_mul
	db	 OP_RM 
	db	2

	dw	038feh
	dw	028f6h
	dd	dgroup:opn_imul
	db	 OP_RM 
	db	2

	dw	038feh
	dw	030f6h
	dd	dgroup:opn_div
	db	 OP_RM 
	db	2

	dw	038feh
	dw	038f6h
	dd	dgroup:opn_idiv
	db	 OP_RM 
	db	2

	dw	0ffh
	dw	0f8h
	dd	dgroup:opn_clc
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0f9h
	dd	dgroup:opn_stc
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0fah
	dd	dgroup:opn_cli
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0fbh
	dd	dgroup:opn_sti
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0fch
	dd	dgroup:opn_cld
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0fdh
	dd	dgroup:opn_std
	db	 OP_CODEONLY
	db	1

	dw	038feh
	dw	0feh
	dd	dgroup:opn_inc
	db	 OP_RM 
	db	2

	dw	038feh
	dw	08feh
	dd	dgroup:opn_dec
	db	 OP_RM 
	db	2

	dw	038ffh
	dw	010ffh
	dd	dgroup:opn_call
	db	 OP_RM 
	db	2

	dw	038ffh
	dw	018ffh
	dd	dgroup:opn_call
	db	 OP_FARRM 
	db	2

	dw	038ffh
	dw	020ffh
	dd	dgroup:opn_jmp
	db	 OP_RM 
	db	2

	dw	038ffh
	dw	028ffh
	dd	dgroup:opn_jmp
	db	 OP_FARRM 
	db	2

	dw	038ffh
	dw	030ffh
	dd	dgroup:opn_push
	db	 OP_NOSTRICTRM
	db	2

	dw	0
	dw	0
	dd	0
	dw	0
	dw	0

base386	dw	0feh
	dw	0beh
	dd	dgroup:opn_movsx
	db	 OP_MIXEDREGRM
	db	2

	dw	0feh
	dw	0b6h
	dd	dgroup:opn_movzx
	db	 OP_MIXEDREGRM
	db	2

	dw	0f7h
	dw	0a0h
	dd	dgroup:opn_push
	db	 OP_SEG35
	db	1

	dw	0f7h
	dw	0a1h
	dd	dgroup:opn_pop
	db	 OP_SEG35
	db	1

	dw	0ffh
	dw	0b4h
	dd	dgroup:opn_lfs
	db	 OP_WORDREGRM
	db	2

	dw	0ffh
	dw	0b5h
	dd	dgroup:opn_lgs
	db	 OP_WORDREGRM
	db	2

	dw	0ffh
	dw	0b2h
	dd	dgroup:opn_lss
	db	 OP_WORDREGRM
	db	2

	dw	0ffh
	dw	06h
	dd	dgroup:opn_clts
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0afh
	dd	dgroup:opn_imul
	db	 OP_WORDREGRM
	db	2

	dw	0ffh
	dw	0a4h
	dd	dgroup:opn_shld
	db	 OP_REGRMSHIFT
	db	3

	dw	0ffh
	dw	0a5h
	dd	dgroup:opn_shld
	db	 OP_REGRMSHIFT
	db	2

	dw	0ffh
	dw	0ach
	dd	dgroup:opn_shrd
	db	 OP_REGRMSHIFT
	db	3

	dw	0ffh
	dw	0adh
	dd	dgroup:opn_shrd
	db	 OP_REGRMSHIFT
	db	2

	dw	0ffh
	dw	0bch
	dd	dgroup:opn_bsf
	db	 OP_WORDREGRM
	db	2

	dw	0ffh
	dw	0bdh
	dd	dgroup:opn_bsr
	db	 OP_WORDREGRM
	db	2

	dw	0ffh
	dw	0a3h
	dd	dgroup:opn_bt
	db	 OP_WORDRMREG
	db	2

	dw	0ffh
	dw	0abh
	dd	dgroup:opn_bts
	db	 OP_WORDRMREG
	db	2

	dw	0ffh
	dw	0b3h
	dd	dgroup:opn_btr
	db	 OP_WORDRMREG
	db	2

	dw	0ffh
	dw	0bbh
	dd	dgroup:opn_btc
	db	 OP_WORDRMREG
	db	2

	dw	038ffh
	dw	020bah
	dd	dgroup:opn_bt
	db	 OP_BITNUM
	db	3

	dw	038ffh
	dw	028bah
	dd	dgroup:opn_bts
	db	 OP_BITNUM
	db	3

	dw	038ffh
	dw	030bah
	dd	dgroup:opn_btr
	db	 OP_BITNUM
	db	3

	dw	038ffh
	dw	038bah
	dd	dgroup:opn_btc
	db	 OP_BITNUM
	db	3

	dw	0ffh
	dw	0a7h
	dd	dgroup:opn_ibts
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	0a6h
	dd	dgroup:opn_xbts
	db	 OP_CODEONLY
	db	1

	dw	0ffh
	dw	080h
	dd	dgroup:opn_jo
	db	 OP_BRANCH
	db	3

	dw	0ffh
	dw	081h
	dd	dgroup:opn_jno
	db	 OP_BRANCH
	db	3

	dw	0ffh
	dw	082h
	dd	dgroup:opn_jb
	db	 OP_BRANCH
	db	3

	dw	0ffh
	dw	083h
	dd	dgroup:opn_jnb
	db	 OP_BRANCH
	db	3

	dw	0ffh
	dw	084h
	dd	dgroup:opn_jz
	db	 OP_BRANCH
	db	3

	dw	0ffh
	dw	085h
	dd	dgroup:opn_jnz
	db	 OP_BRANCH
	db	3

	dw	0ffh
	dw	086h
	dd	dgroup:opn_jbe
	db	 OP_BRANCH
	db	3

	dw	0ffh
	dw	087h
	dd	dgroup:opn_ja
	db	 OP_BRANCH
	db	3

	dw	0ffh
	dw	088h
	dd	dgroup:opn_js
	db	 OP_BRANCH
	db	3

	dw	0ffh
	dw	089h
	dd	dgroup:opn_jns
	db	 OP_BRANCH
	db	3

	dw	0ffh
	dw	08ah
	dd	dgroup:opn_jp
	db	 OP_BRANCH
	db	3

	dw	0ffh
	dw	08bh
	dd	dgroup:opn_jnp
	db	 OP_BRANCH
	db	3

	dw	0ffh
	dw	08ch
	dd	dgroup:opn_jl
	db	 OP_BRANCH
	db	3

	dw	0ffh
	dw	08dh
	dd	dgroup:opn_jge
	db	 OP_BRANCH
	db	3

	dw	0ffh
	dw	08eh
	dd	dgroup:opn_jle
	db	 OP_BRANCH
	db	3

	dw	0ffh
	dw	08fh
	dd	dgroup:opn_jg
	db	 OP_BRANCH
	db	3

	dw	038ffh
	dw	090h
	dd	dgroup:opn_seto
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	091h
	dd	dgroup:opn_setno
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	092h
	dd	dgroup:opn_setb
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	093h
	dd	dgroup:opn_setnb
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	094h
	dd	dgroup:opn_setz
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	095h
	dd	dgroup:opn_setnz
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	096h
	dd	dgroup:opn_setbe
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	097h
	dd	dgroup:opn_seta
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	098h
	dd	dgroup:opn_sets
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	099h
	dd	dgroup:opn_setns
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	09ah
	dd	dgroup:opn_setp
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	09bh
	dd	dgroup:opn_setnp
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	09ch
	dd	dgroup:opn_setl
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	09dh
	dd	dgroup:opn_setge
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	09eh
	dd	dgroup:opn_setle
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	09fh
	dd	dgroup:opn_setg
	db	 OP_NOSTRICTRM 
	db	2

	dw	0c0fdh
	dw	0c020h
	dd	dgroup:opn_mov
	db	 OP_386REG
	db	2

	dw	0c0fdh
	dw	0c021h
	dd	dgroup:opn_mov
	db	 OP_386REG
	db	2

	dw	0c0fdh
	dw	0c024h
	dd	dgroup:opn_mov
	db	 OP_386REG
	db	2

	dw	0ffh
	dw	02h
	dd	dgroup:opn_lar
	db	 OP_WORDREGRM
	db	2

	dw	0ffh
	dw	03h
	dd	dgroup:opn_lsl
	db	 OP_WORDREGRM
	db	2

	dw	038ffh
	dw	01001h
	dd	dgroup:opn_lgdt
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	01801h
	dd	dgroup:opn_lidt
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	01000h
	dd	dgroup:opn_lldt
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	03001h
	dd	dgroup:opn_lmsw
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	01800h
	dd	dgroup:opn_ltr
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	01h
	dd	dgroup:opn_sgdt
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	0801h
	dd	dgroup:opn_sidt
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	00h
	dd	dgroup:opn_sldt
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	02001h
	dd	dgroup:opn_smsw
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	0800h
	dd	dgroup:opn_str
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	02000h
	dd	dgroup:opn_verr
	db	 OP_NOSTRICTRM 
	db	2

	dw	038ffh
	dw	02800h
	dd	dgroup:opn_verw
	db	 OP_NOSTRICTRM 
	db	2

	dw	0
	dw	0
	dd	0
	dw	0
	dw	0

;/* single byte commands */
floats	dw	0ffffh
	dw	0d0d9h
	dd	dgroup:opn_fnop
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0e0d9h
	dd	dgroup:opn_fchs
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0e1d9h
	dd	dgroup:opn_fabs
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0e4d9h
	dd	dgroup:opn_ftst
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0e5d9h
	dd	dgroup:opn_fxam
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0e8d9h
	dd	dgroup:opn_fld1
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0e9d9h
	dd	dgroup:opn_fldl2t
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0ead9h
	dd	dgroup:opn_fldl2e
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0ebd9h
	dd	dgroup:opn_fldpi
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0ecd9h
	dd	dgroup:opn_fldlg2
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0edd9h
	dd	dgroup:opn_fldln2
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0eed9h
	dd	dgroup:opn_fldz
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0f0d9h
	dd	dgroup:opn_f2xm1
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0f1d9h
	dd	dgroup:opn_fyl2x
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0f2d9h
	dd	dgroup:opn_fptan
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0f3d9h
	dd	dgroup:opn_fpatan
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0f5d9h
	dd	dgroup:opn_fprem1
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0f4d9h
	dd	dgroup:opn_fxtract
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0f6d9h
	dd	dgroup:opn_fdecstp
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0f7d9h
	dd	dgroup:opn_fincstp
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0f8d9h
	dd	dgroup:opn_fprem
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0f9d9h
	dd	dgroup:opn_fyl2xp1
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0fad9h
	dd	dgroup:opn_fsqrt
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0fbd9h
	dd	dgroup:opn_fsincos
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0fcd9h
	dd	dgroup:opn_frndint
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0fdd9h
	dd	dgroup:opn_fscale
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0fed9h
	dd	dgroup:opn_fsin
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0ffd9h
	dd	dgroup:opn_fcos
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0e9dah
	dd	dgroup:opn_fucompp
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0e0dbh
	dd	dgroup:opn_feni
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0e1dbh
	dd	dgroup:opn_fdisi
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0e2dbh
	dd	dgroup:opn_fclex
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0e3dbh
	dd	dgroup:opn_finit
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0e4dbh
	dd	dgroup:opn_fsetpm
	db	 OP_CODEONLY
	db	2

	dw	0ffffh
	dw	0d9deh
	dd	dgroup:opn_fcompp
	db	 OP_CODEONLY
	db	2


;  /* Group 1, RM 3 */
	dw	0f8ffh
	dw	0c0d9h
	dd	dgroup:opn_fld
	db	 OP_FLOATRM
	db	2

	dw	0f8ffh
	dw	0c8d9h
	dd	dgroup:opn_fxch
	db	 OP_FLOATRM
	db	2

	dw	0f8fbh
	dw	0d8d9h
	dd	dgroup:opn_fstp
	db	 OP_FLOATRM
	db	2

	dw	0c0ffh
	dw	0c0d9h
	dd	dgroup:opn_esc
	db	 OP_ESC
	db	2


;  /* Group 1, RM0-2 */
	dw	038ffh
	dw	020d9h
	dd	dgroup:opn_fldenv
	db	 OP_FLOATNOPTR
	db	2

	dw	038ffh
	dw	028d9h
	dd	dgroup:opn_fldcw
	db	 OP_FLOATNOPTR
	db	2

	dw	038ffh
	dw	030d9h
	dd	dgroup:opn_fstenv
	db	 OP_FLOATNOPTR
	db	2

	dw	038ffh
	dw	038d9h
	dd	dgroup:opn_fstcw
	db	 OP_FLOATNOPTR
	db	2


;  /* Group 5, RM3 */
	dw	0f8ffh
	dw	0c0ddh
	dd	dgroup:opn_ffree
	db	 OP_FLOATRM
	db	2

	dw	0f8ffh
	dw	0d0ddh
	dd	dgroup:opn_fst
	db	 OP_FLOATRM
	db	2

	dw	0f8ffh
	dw	0e0ddh
	dd	dgroup:opn_fucom
	db	 OP_FLOATRM
	db	2

	dw	0f8ffh
	dw	0e8ddh
	dd	dgroup:opn_fucomp
	db	 OP_FLOATRM
	db	2


	dw	0c0ffh
	dw	0c0ddh
	dd	dgroup:opn_esc
	db	 OP_ESC
	db	2


;  /* Group 5, RM0-2 */
	dw	038ffh
	dw	020ddh
	dd	dgroup:opn_frstor
	db	 OP_FLOATNOPTR
	db	2

	dw	038ffh
	dw	030ddh
	dd	dgroup:opn_fsave
	db	 OP_FLOATNOPTR
	db	2

	dw	038ffh
	dw	038ddh
	dd	dgroup:opn_fstsw
	db	 OP_FLOATNOPTR
	db	2


;  /* Group 3 & 7*/
	dw	0c0fbh
	dw	0c0dbh
	dd	dgroup:opn_esc
	db	 OP_ESC
	db	2

	dw	038ffh
	dw	028dbh
	dd	dgroup:opn_fld
	db	 OP_SIZEFLOATRM
	db	2

	dw	038ffh
	dw	038dbh
	dd	dgroup:opn_fstp
	db	 OP_SIZEFLOATRM
	db	2


;  /* Group 7 */
	dw	038ffh
	dw	020dfh
	dd	dgroup:opn_fbld
	db	 OP_SIZEFLOATRM
	db	2

	dw	038ffh
	dw	028dfh
	dd	dgroup:opn_fild
	db	 OP_SIZEFLOATRM
	db	2

	dw	038ffh
	dw	030dfh
	dd	dgroup:opn_fbstp
	db	 OP_SIZEFLOATRM
	db	2

	dw	038ffh
	dw	038dfh
	dd	dgroup:opn_fistp
	db	 OP_SIZEFLOATRM
	db	2


;  /* Math, group 0,2,4,6 special RM 3*/
	dw	0c0ffh
	dw	0c0dah
	dd	dgroup:opn_esc
	db	 OP_ESC
	db	2

	dw	0f8ffh
	dw	0c0deh
	dd	dgroup:opn_fadd
	db	 OP_FLOATMATH
	db	2

	dw	0f8ffh
	dw	0c8deh
	dd	dgroup:opn_fmul
	db	 OP_FLOATMATH
	db	2

	dw	0f8ffh
	dw	0d0deh
	dd	dgroup:opn_fcom
	db	 OP_FLOATRM
	db	2

	dw	0f8ffh
	dw	0d8deh
	dd	dgroup:opn_esc
	db	 OP_ESC
	db	2

	dw	0f0ffh
	dw	0e0deh
	dd	dgroup:opn_fsub
	db	 OP_FLOATMATH
	db	2

	dw	0f0ffh
	dw	0f0deh
	dd	dgroup:opn_fdiv
	db	 OP_FLOATMATH
	db	2


;  /* Math, other */
	dw	038fbh
	dw	0d8h
	dd	dgroup:opn_fadd
	db	 OP_FLOATMATH
	db	2

	dw	038fbh
	dw	08d8h
	dd	dgroup:opn_fmul
	db	 OP_FLOATMATH
	db	2

	dw	038fbh
	dw	010d8h
	dd	dgroup:opn_fcom
	db	 OP_FLOATRM
	db	2

	dw	038fbh
	dw	018d8h
	dd	dgroup:opn_fcomp
	db	 OP_FLOATRM
	db	2

	dw	030fbh
	dw	020d8h
	dd	dgroup:opn_fsub
	db	 OP_FLOATMATH
	db	2

	dw	030fbh
	dw	030d8h
	dd	dgroup:opn_fdiv
	db	 OP_FLOATMATH
	db	2

	dw	038fbh
	dw	0dah
	dd	dgroup:opn_fiadd
	db	 OP_FLOATMATH
	db	2

	dw	038fbh
	dw	08dah
	dd	dgroup:opn_fimul
	db	 OP_FLOATMATH
	db	2

	dw	038fbh
	dw	010dah
	dd	dgroup:opn_ficom
	db	 OP_FLOATRM
	db	2

	dw	038fbh
	dw	018dah
	dd	dgroup:opn_ficomp
	db	 OP_FLOATRM
	db	2

	dw	030fbh
	dw	020dah
	dd	dgroup:opn_fisub
	db	 OP_FLOATMATH
	db	2

	dw	030fbh
	dw	030dah
	dd	dgroup:opn_fidiv
	db	 OP_FLOATMATH
	db	2


;  /* groups 1, 3, 5, 7 */
;  /* keep the follwing from going into error, RM3 */
	dw	0e0f9h
	dw	0c0d9h
	dd	dgroup:opn_esc
	db	 OP_ESC
	db	2

	dw	038fbh
	dw	0d9h
	dd	dgroup:opn_fld
	db	 OP_FLOATRM
	db	2

	dw	038fbh
	dw	010d9h
	dd	dgroup:opn_fst
	db	 OP_FLOATRM
	db	2

	dw	038fbh
	dw	018d9h
	dd	dgroup:opn_fstp
	db	 OP_FLOATRM
	db	2

	dw	038fbh
	dw	0dbh
	dd	dgroup:opn_fild
	db	 OP_FLOATRM
	db	2

	dw	038fbh
	dw	010dbh
	dd	dgroup:opn_fist
	db	 OP_FLOATRM
	db	2

	dw	038fbh
	dw	018dbh
	dd	dgroup:opn_fistp
	db	 OP_FLOATRM
	db	2


;  /* Catch- all */
	dw	0f8h
	dw	0d8h
	dd	dgroup:opn_esc
	db	 OP_ESC
	db	2

	dw	0
	dw	0
	dd	0
	dw	0
	dw	0

indexes dd dgroup:base0, dgroup:base1, dgroup:base2, dgroup:base3
	dd dgroup:base4, dgroup:base5, dgroup:base6, dgroup:base7
seg386data	ENDS	

seg386	SEGMENT	
FindOpcode	PROC	
	mov	ebx,offset dgroup:base386	; Assume it is an 0F opcode
	inc	esi			; Point to next byte
	cmp	BYTE PTR es:[esi-1],0fh	; Is it?
	jz	short gotable		; Yes, go parse second byte
	dec	esi			; Else point back to first byte
	mov	ebx,offset dgroup:floats	; Assume floating
	sub	eax,eax			;
	mov	al,es:[esi]		; Get the opcode
	and	al,0f8h			; Apply the FLOAT mask
	cmp	al,0d8h			; Apply FLOAT compare
	jz	short gotable		; Yes, go look for opcode
	shr	al,5			; Else use upper three bits of
	mov	ebx,[indexes + eax * 4]	; opcode to select a table
gotable:
	test	WORD PTR [ebx],-1	; See if at end of table
	jz	short noentry		; Yes, not found
	mov	ax,es:[esi]		; Get the opcode
	and	ax,[ebx + OPCODE.MSK]	; Mask it
	cmp	ax,[ebx + OPCODE.COMPARE]; Compare with the compare value
	jz	short gotentry		; Quit if found
	add	ebx,OPCODESIZE		; Else go to next entry
	jmp	gotable			;
gotentry:
	clc				; Found, exit
	ret
noentry:
	stc				; Not found, exit
	ret
FindOpcode	ENDP	
seg386	ENDS	
END