
/* MKLibHead 1.00 Wednesday February 15, 1995  21:18:15 */

#ifndef __OSLIBPROT__
#define __OSLIBPROT__

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

                               /* Dos.asm */

   int OSDosOpenFile(char *filename, unsigned mode);
   int OSDosCreatFile(char *filename);
   int OSDosCloseFile(int handle);
   int OSDosReadFile(int handle, unsigned char *buffer, int size, int *sizeret);
   int OSDosWriteFile(int handle, unsigned char *buffer, int size, int *sizeret);
   int OSDosPositionFile(int handle, int position);

                               /* Fs.asm */

   int OSMakeFS(int drive);
   int OSFlushBuffers(void);
   int OSOpenFile(int drive, char *filename, int *handle);
   int OSCreateFile(int drive, char *filename, int *handle);
   int OSCloseFile(int handle);
   int OSDeleteFile(int drive, char *filename);
   int OSTruncateFile(int handle);
   int OSRenameFile(int drive, char *orig, char*new);
   int OSReadFile(int handle, int size, unsigned char *buffer, int*sizeread);
   int OSWriteFile(int handle, int size, unsigned char *buffer, int *sizeread);
   int OSFileSetPosition(int handle, int position, int method);
   int OSFileGetPosition(int handle, int *position);
   int OSFilePositionAtEOF(int handle);
   int OSFileSetTime(int handle, int time);
   int OSFileGetTime(int handle, unsigned *time);
   int OSGetStdHandle(int htype);
   int OSGetHandleType(int handle);
   int OSGetLastError(void);

                               /* Kb.asm */

   int OSGetKey(void);
   int OSGetKeyExtended(void);
   int OSGetKeyStatus(void);

                              /* Task.asm */

   int OSRunProgram(char *name);
   int OSRunProgramAndWait(char *name);
   int OSSpawnChild(int address);
   int OSSpawnChildAndWait(int address);
   void OSPause(void);
   void OSEndTask(int endval);
   void OSRundownOS(void);

                              /* Video.asm */

   void OSPutChar(char item);
   void OSPutExtendedChar(char item);
   void OSPutText(char *text);
   void OSClearTextScreen(void);
   void OSSetTextAttribute(int attribute);
   void OSSetTextCursor(int row, int col);
   int OSGetTextAttribute(void);
   void OSGetTextCursor(int *row, int *col);
   void OSBlankScreen(void);
   void OSUnblankScreen(void);

                             /* Memory.asm */

   void *OSMemAllocate(int size);
   void OSMemDeallocate(void * address);
   int OSMemCommit(void *address, int ASIZE);
   int OSMemDecommit(void *addres, int ASIZE);

                             /* Floppy.asm */

   void OSFloppyReset(void);
   int OSFloppyFormat(int drive, unsigned char *buffer);
   int OSFloppyRead(int drive,int sector, unsigned char *buffer);
   int OSFloppyWrite(int drive, int sector, unsigned char *buffer);
   int OSFloppyVerify(int drive, int sector);
   int OSFloppyGetSectors(int drive);

                              /* Mouse.asm */

   void OSMouseAttach(int line);
   void OSMouseDetach(void);
   void OSMouseShow(void);
   int OSMouseHide(void);
   void OSMouseCondShow(int flag);
   void OSMouseGetState(int *flags, int *row, int *col);
   void OSMouseSetCursor(unsigned char *cursor, int hotrow, int hotcol);

                             /* Serial.asm */

   void OSSerialEnable(int line);
   void OSSerialDisable(int line);
   void OSSerialPutChar(int line, unsigned char theChar);
   unsigned char OSSerialGetChar(int line);
   void OSSerialSetMode(int line, int modes, int baudrate);
   int OSSerialGetMode(int line);
   void OSSerialClearTransmit(int line);
   void OSSerialClearReceive(int line);
   int OSSerialTransmitStatus(int line);
   int OSSerialReceiveStatus(int line);

                               /* Vga.asm */

   void OSVGATextMode(void);
   void OSVGAGraphicsMode(void);
   void OSVGAClearScreen(void);
   void OSVGATextChar(int pos, int achar, int fg, int bg, unsigned char *font);
   void OSVGAWideTextChar(int pos, int achar, int fg, int bg, unsigned char *font);
   void OSVGATallTextChar(int pos, int achar, int fg,int bg, unsigned char *font);
   void OSVGAHorizBar(int pos, int fg, int len);
   void OSVGAVertBar(int pos, int fg, int width, int len);
   void OSVGAFillCorner(int pos, int fg, int offset);

                              /* Misc.asm */

   unsigned OSGetTicks(void);
   unsigned OSConvertToMS(unsigned value);
   unsigned OSConvertToTicks(unsigned value);
   void OSSetDate(int day, int month, int year);
   void OSSetTime(int hr, int min, int sec);
   void OSGetDate(int *day, int *month, int *year);
   void OSGetTime(int *hr, int *min, int *sec);
   void OSEnableWatchDog(void);
   void OSDisableWatchDog(void);
   void OSResetWatchDog(void);
   int OSGetVersion(void);

#ifdef __cplusplus
}
#endif // __cplusplus
#endif // __OSLIBPROT__
